/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description        : ϵͳ˯ģʽʾGPIOA_5ΪԴ4˯ߵȼ
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

/*
 ע⣺лHSEʱԴȴȶʱѡþйأѡһµľĶṩľ弰
 صݲֵͨR8_XT32M_TUNEĴòͬĸصݺƫõȶʱ䡣
 */

#include "CH58x_common.h"

/*********************************************************************
 * @fn      DebugInit
 *
 * @brief   Գʼ
 *
 * @return  none
 */
void DebugInit(void)
{
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
}

#define TEST_IO_OFF()      GPIOB_ResetBits(GPIO_Pin_19)
#define TEST_IO_ON()     GPIOB_SetBits(GPIO_Pin_19)
#define TEST_IO_TOG()     GPIOB_InverseBits(GPIO_Pin_19)

/*********************************************************************
 * @fn      main
 *
 * @brief   
 *
 * @return  none
 */
int main()
{
    uint8_t i = 0;
    SetSysClock(CLK_SOURCE_PLL_60MHz);

    GPIOA_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PU);
    GPIOB_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PU);

    /* ôڵ */
    DebugInit();
    PRINT("Start @ChipID=%02x\n", R8_CHIP_ID);
    DelayMs(200);
    
    GPIOB_ModeCfg(GPIO_Pin_19, GPIO_ModeOut_PP_20mA); // B19 - IO

    while(1)
    {
        TEST_IO_ON();
        DelayMs(300);

        TEST_IO_OFF();
        DelayUs(1);

        for (i = 0; i < 10; i++)
        {
            TEST_IO_ON();
            DelayMs(110);

            TEST_IO_OFF();
            DelayMs(110);
        }
    }

#if 1
    /* ûԴΪ GPIO - PA5 */
    GPIOA_ModeCfg(GPIO_Pin_5, GPIO_ModeIN_PU);
    GPIOA_ITModeCfg(GPIO_Pin_5, GPIO_ITMode_FallEdge); // ½ػ
    PFIC_EnableIRQ(GPIO_A_IRQn);
    PWR_PeriphWakeUpCfg(ENABLE, RB_SLP_GPIO_WAKE, Long_Delay);
#endif

#if 1
    PRINT("IDLE mode sleep \n");
    DelayMs(1);
    LowPower_Idle();
    PRINT("wake.. \n");
    DelayMs(500);
#endif

#if 1
    PRINT("Halt mode sleep \n");
    DelayMs(2);
    LowPower_Halt();
    HSECFG_Current(HSE_RCur_100); // Ϊ(͹ĺHSEƫõ)
    DelayMs(2);
    PRINT("wake.. \n");
    DelayMs(500);
#endif

#if 1
    PRINT("sleep mode sleep \n");
    DelayMs(2);
    // ע⵱ƵΪ80MʱSleep˯߻жϲɵflashڴ롣
    LowPower_Sleep(RB_PWR_RAM30K | RB_PWR_RAM2K); //ֻ30+2K SRAM 
    HSECFG_Current(HSE_RCur_100);                 // Ϊ(͹ĺHSEƫõ)
    DelayMs(5);
    PRINT("wake.. \n");
    DelayMs(500);
#endif

#if 0
    PRINT("shut down mode sleep \n");
    DelayMs(2);
    LowPower_Shutdown(0); //ȫϵ磬Ѻλ
    /*
     ģʽѺִиλ벻У
     עҪȷϵͳ˯ȥٻѲǻѸλпܱIDLEȼ
     */
    HSECFG_Current(HSE_RCur_100); // Ϊ(͹ĺHSEƫõ)
    PRINT("wake.. \n");
    DelayMs(500);
#endif

    while(1)
        ;
}

/*********************************************************************
 * @fn      GPIOA_IRQHandler
 *
 * @brief   GPIOAжϺ
 *
 * @return  none
 */
__INTERRUPT
__HIGH_CODE
void GPIOA_IRQHandler(void)
{
    GPIOA_ClearITFlagBit(GPIO_Pin_6 | GPIO_Pin_5);

    GPIOB_SetBits(GPIO_Pin_19);
    GPIOB_ResetBits(GPIO_Pin_19);
}
